//
//  SFDigestStream.h
//  UCPFramework
//
//  Created by Christian Weykopf on 05.10.09.
//  Copyright 2009 STARFACE GmbH. All rights reserved.
//

#import <Foundation/Foundation.h>

extern NSString * const SFDigestTypeMD5;
extern NSString * const SFDigestTypeSHA;

@interface SFDigestStream : NSInputStream
{
#if !TARGET_OS_IPHONE
    CSSM_CSP_HANDLE _cspHandle;
    CSSM_ALGORITHMS _digestAlg;
    CSSM_DATA _fileDigestData;
    CSSM_CC_HANDLE _ccHandle;
#endif
    NSInputStream *_inStream;
}

@property (readonly) NSData *fileDigest;

- (id)initWithFileAtPath: (NSString *)path digestType: (NSString *)digestType;
- (NSUInteger)read: (NSMutableData *)buffer maxLength:(NSUInteger)len digest: (NSMutableData *)digest;

@end
