//
//  UCPFileTransferAgent.h
//  UCPFramework
//
//  Created by Christian Weykopf on 17.09.09.
//  Copyright 2009 STARFACE GmbH. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "UCPServerService.h"

@interface UCPFileTransferAgent : UCPServerService
{

}

@end

/*
 Filetransfer haben wir über XML-RPC realisiert. D.h. im Klartext, daß es (so wie die UCI-Interfaces) eine Schnittstelle ist, welche 3 Methoden implementiert, welche in der richtigen Reihenfolge aufgerufen werden müssen:
 
 ucp.v21.server.filetransfer
 * initializeTransfer - ruft man, bevor man die Daten überträgt um dem Server mitzuteilen, daß bzw. was für eine Datei übertragen wird
 * sendBlock -  wird sooft aufgerufen, wie man Datenblöcke schickt; D.h. im ungünstigsten Fall genau einmal, wenn man die ganze Datei am stück schickt. Ich empfehle jedoch eine Stückelung in 4000 byte-Blöcke.
 blocknummer ab 
 * finishTransfer - wird aufgerufen um dem server mitzuteilen, daß das jetzt alles war oder um den Transfer vorzeitig abzubrechen.
 
 Per default wird als Digest "SHA" verwendet, initializeTransfer erlaubt aber auch das Setzen eines "MD5"-digest. Selbiger ist jeweils einmal pro Block und einmal am Ende für den gesamten File zu übermitteln (hier auf Effizienz achten, wir berechne den Digest während des Lesens der Datei und nicht komplett zum Schluss, da letzteres bei einer 100MB-PDF-Datei sehr viel Ressourcen schluckt ! )
 
 Anbei die JavaDoc zu dem Interface, das ist derzeit die bestmögliche Schnittstellenbeschreibung, die ich für Sie habe. Ich würde aber vorschlagen, daß Sie mich heute ab 16.00 oder morgen Vormittag anrufen können. Direkt kann ich den einen oder anderen Aspekt vielleicht besser verdeutlichen. */